/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef TRACKSTATE_H
#define TRACKSTATE_H

#include "Vector.h"
#include "NetworkMessage.h"

struct TrackCarState
{
	Vector velocity;
	Vector position;
	double rotationVelocity;
	double rotation;
	int tileOrderNum;
	int lap;
	int posFinished;
	double timeFinished;
};

struct TrackState
{
	double time;
	int timeState;
	TrackCarState* cars;
	
	TrackState();
	~TrackState();
	void setCars(int nCars);
	void removeCar(int carId, int nCars);
	void write(NetworkMessage& msg, int nCars) const;
	void read(NetworkMessage& msg, int nCars);
};

#endif
